/// A light-weight library for event sourcing with dart
///
library eventuous;

export 'src/app/service.dart';
export 'src/app/enums.dart';
export 'src/app/handlers.dart';
export 'src/app/result.dart';
export 'src/app/typedefs.dart';
export 'src/constants.dart';
export 'src/exceptions.dart';
export 'src/extensions.dart';
export 'src/helpers.dart';
export 'src/json/json_object.dart';
export 'src/json/json_typedefs.dart';
export 'src/state/aggregate.dart';
export 'src/state/aggregate_id.dart';
export 'src/state/aggregate_state.dart';
export 'src/state/aggregate_state_store.dart';
export 'src/state/aggregate_state_type.dart';
export 'src/state/aggregate_type.dart';
export 'src/stream/event_typedefs.dart';
export 'src/stream/event_handler.dart';
export 'src/stream/event_store.dart';
export 'src/stream/event_store_result.dart';
export 'src/stream/event_type.dart';
export 'src/stream/metadata.dart';
export 'src/stream/serializer.dart';
export 'src/stream/stream_event.dart';
export 'src/stream/stream_name.dart';
export 'src/stream/version.dart';
